## jpegqs 1.20210408

=== Makefile ===

SRCDEPS := quantsmooth.h idct.h libjpegqs.h
SRCNAME ?= quantsmooth.c
ifeq ($(SRCNAME),jpegqs-mini.c)
APPNAME ?= jpegqs-mini
$(APPNAME): Makefile
else
ifeq ($(SRCNAME),example.c)
APPNAME ?= example
else
APPNAME ?= jpegqs
endif
$(APPNAME): Makefile $(SRCDEPS)
endif
SIMD := native
# machine flags
MFLAGS := 
SIMDFLG :=
SIMDOBJ :=
ifeq ($(SIMD),select)
SIMDOBJ := jpegqs_base.o jpegqs_sse2.o jpegqs_avx2.o jpegqs_avx512.o
else ifeq ($(SIMD),none)
SIMDFLG := -DNO_SIMD
else ifeq ($(SIMD),native)
SIMDFLG := -march=native
else ifeq ($(SIMD),avx512)
SIMDFLG := -mavx512f -mfma
else ifeq ($(SIMD),avx2)
SIMDFLG := -mavx2 -mfma
else ifeq ($(SIMD),sse2)
SIMDFLG := -msse2
endif
# multithreading options
MTOPTS := -fopenmp
# path to save "libgomp.a"
LIBMINIOMP :=
CFLAGS := -Wall -O2
LDFLAGS := -Wl,--gc-sections -s

CFLAGS_LIB := $(CFLAGS) $(MFLAGS) $(SIMDFLG)
CFLAGS_APP := $(CFLAGS_LIB) -Wextra -pedantic $(MTOPTS)
ifeq ($(SIMD),select)
CFLAGS_APP += -DSIMD_SELECT
endif

.PHONY: clean all app lib

app: $(APPNAME)
all: app lib
lib: lib$(APPNAME).a

WGET_CMD = @echo "run make with WGET_CMD=wget to allow file downloads" ; echo "DISABLED:" wget

jpegsrc.v%.tar.gz: 
	$(WGET_CMD) -O $@ "https://www.ijg.org/files/$@"
	test -f $@
jpeg-%/jutils.c: jpegsrc.v%.tar.gz
	tar -xzf jpegsrc.v$(patsubst jpeg-%/jutils.c,%,$@).tar.gz
	touch $@
jpeg-%/Makefile: jpeg-%/jutils.c
	cd $(patsubst %/Makefile,%,$@) && ./configure
jpeg-%/libjpeg.a: jpeg-%/Makefile
	cd $(patsubst %/libjpeg.a,%,$@) && $(MAKE) all && test -d .libs && cp .libs/libjpeg.a . || true
.PRECIOUS: jpegsrc.v%.tar.gz jpeg-%/jutils.c jpeg-%/Makefile

libjpeg-turbo-%.tar.gz:
	$(WGET_CMD) -O $@ "https://sourceforge.net/projects/libjpeg-turbo/files/$(patsubst libjpeg-turbo-%.tar.gz,%,$@)/libjpeg-turbo-$(patsubst libjpeg-turbo-%.tar.gz,%,$@).tar.gz"
	test -f $@
libjpeg-turbo-%/jutils.c: libjpeg-turbo-%.tar.gz
	tar -xzf $(patsubst %/jutils.c,%,$@).tar.gz
	touch $@
.PRECIOUS: libjpeg-turbo-%.tar.gz libjpeg-turbo-%/jutils.c
libjpeg-turbo-1.%/Makefile: libjpeg-turbo-1.%/jutils.c
	cd $(patsubst %/Makefile,%,$@) && ./configure
libjpeg-turbo-1.%/libjpeg.a: libjpeg-turbo-1.%/Makefile
	cd $(patsubst %/libjpeg.a,%,$@) && $(MAKE) all && cp .libs/lib*jpeg.a .
.PRECIOUS: libjpeg-turbo-1.%/Makefile
libjpeg-turbo-2.%/.libs/Makefile: libjpeg-turbo-2.%/jutils.c
	mkdir -p $(patsubst %/Makefile,%,$@)
	cd $(patsubst %/Makefile,%,$@) && cmake -G"Unix Makefiles" ..
libjpeg-turbo-2.%/libjpeg.a: libjpeg-turbo-2.%/.libs/Makefile
	cd $(patsubst %/Makefile,%,$<) && $(MAKE) all && cp jconfig*.h lib*jpeg.a ..
.PRECIOUS: libjpeg-turbo-2.%/.libs/Makefile

ifeq ($(JPEGSRC),)
JPEGLIB ?= -ljpeg
JPEGLIB2 := $(JPEGLIB)
CFLAGS_APP += $(filter -I%,$(JPEGLIB))
OBJLIST :=
else
OBJDIR ?= $(JPEGSRC)
ALLSRC := $(patsubst $(JPEGSRC)/%.c,%,$(wildcard $(JPEGSRC)/*.c))
SOURCES := jutils jmemmgr jmemnobs jcomapi jerror \
  jdapimin jdcoefct jdmarker jdhuff jdinput jdtrans \
  jcapimin jcmaster jcmarker jchuff jcparam jctrans \
	rdswitch cdjpeg transupp jdatasrc jdatadst
ifeq ($(SRCNAME),jpegqs-mini.c)
SOURCES += jidctint jfdctint
else ifeq ($(SRCNAME),example.c)
SOURCES += jidctint jidctfst jidctflt jquant1 jquant2 \
	jdapistd jdmaster jdcolor jdpostct jddctmgr jdsample jdmerge jdmainct
SOURCES += $(filter jidctred,$(ALLSRC))
endif
# version specific sources
SOURCES += $(filter jdphuff jcphuff jaricom jdarith jcarith,$(ALLSRC))

OBJLIST := $(patsubst %,$(OBJDIR)/%.o,$(SOURCES))
CFLAGS_APP += -DWITH_JPEGSRC -I$(JPEGSRC) -I.

$(OBJDIR)/%.o: $(JPEGSRC)/%.c
	$(CC) $(CFLAGS_LIB) -I$(JPEGSRC) -I. -c -o $@ $<

JPEGLIB2 := $(OBJLIST)
$(APPNAME): $(OBJLIST)
endif

clean:
	rm -f $(APPNAME) $(OBJLIST) jpegqs_*.o libjpegqs*.o lib$(APPNAME).a miniomp.o $(LIBMINIOMP)

ifneq ($(LIBMINIOMP),)
JPEGLIB2 += -L$(dir $(LIBMINIOMP))
$(APPNAME): $(LIBMINIOMP)
endif

$(APPNAME): $(SRCNAME) $(SIMDOBJ)
	$(CC) $(CFLAGS_APP) -DAPPNAME=$(APPNAME) -o $@ $< $(JPEGLIB2) $(SIMDOBJ) $(LDFLAGS) -lm

ifeq ($(SRCNAME),example.c)
SIMDSEL_FLAGS ?=
else
SIMDSEL_FLAGS ?= -DTRANSCODE_ONLY -DWITH_LOG
endif

jpegqs_avx512.o: libjpegqs.c $(SRCDEPS)
	$(CC) $(SIMDSEL_FLAGS) -DSIMD_NAME=avx512 -mavx512f -mfma $(CFLAGS_APP) -DSIMD_AVX512 -c -o $@ $<
jpegqs_avx2.o: libjpegqs.c $(SRCDEPS)
	$(CC) $(SIMDSEL_FLAGS) -DSIMD_NAME=avx2 -mavx2 -mfma $(CFLAGS_APP) -DSIMD_AVX2 -c -o $@ $<
jpegqs_sse2.o: libjpegqs.c $(SRCDEPS)
	$(CC) $(SIMDSEL_FLAGS) -DSIMD_NAME=sse2 -msse2 $(CFLAGS_APP) -DSIMD_SSE2 -c -o $@ $<
jpegqs_base.o: libjpegqs.c $(SRCDEPS)
	$(CC) $(SIMDSEL_FLAGS) -DSIMD_NAME=base $(CFLAGS_APP) -DSIMD_BASE -c -o $@ $<

ifeq ($(SIMD),select)
lib$(APPNAME).a: libjpegqs_base.o libjpegqs_sse2.o libjpegqs_avx2.o libjpegqs_avx512.o
endif
lib$(APPNAME).a: libjpegqs.o
	$(AR) -rsc $@ $^

libjpegqs.o: libjpegqs.c $(SRCDEPS)
	$(CC) $(CFLAGS_APP) -c -o $@ $<
libjpegqs_avx512.o: libjpegqs.c $(SRCDEPS)
	$(CC) -DSIMD_NAME=avx512 -mavx512f -mfma $(CFLAGS_APP) -DSIMD_AVX512 -c -o $@ $<
libjpegqs_avx2.o: libjpegqs.c $(SRCDEPS)
	$(CC) -DSIMD_NAME=avx2 -mavx2 -mfma $(CFLAGS_APP) -DSIMD_AVX2 -c -o $@ $<
libjpegqs_sse2.o: libjpegqs.c $(SRCDEPS)
	$(CC) -DSIMD_NAME=sse2 -msse2 $(CFLAGS_APP) -DSIMD_SSE2 -c -o $@ $<
libjpegqs_base.o: libjpegqs.c $(SRCDEPS)
	$(CC) -DSIMD_NAME=base $(CFLAGS_APP) -DSIMD_BASE -c -o $@ $<

$(LIBMINIOMP): miniomp.o
	$(AR) -rsc $@ $^
miniomp.o: miniomp.c
	$(CC) -DOVERFLOW_CHECKS=0 -O2 -Wall -Wextra -c -o $@ $< -ffunction-sections -fdata-sections

=== irfanview/Makefile ===

LIBNAME ?= jpegqs.dll
SONAME ?= JPEGQS.DLL
MTOPTS ?= -fopenmp
CFLAGS := -O2 -Wall -Wextra -pedantic -municode -I.. $(MTOPTS)
JPEGLIB ?= -ljpeg -static

.PHONY: all clean

all: $(LIBNAME)

clean:
	rm -f $(LIBNAME)

$(LIBNAME): plugin.c
	$(CC) $(CFLAGS) -shared -Wl,-soname,$(SONAME) -o $@ $< $(JPEGLIB) -Wl,--version-script,plugin-vers.txt -Wl,--gc-sections
	strip $@

=== windows/Makefile ===

APPNAME ?= jpegqs_gui
SRCNAME ?= jpegqs_gui.c

CFLAGS := -Wall -Wextra -pedantic -O2 -mwindows
CFLAGS += -DWITH_DROP
CFLAGS += -DSHORTCUT_MENU
LIBS := -lcomdlg32

.PHONY: clean all

all: $(APPNAME)

$(APPNAME): dialog.h
dialog.o: dialog.rc dialog.h
	windres $< $@

clean:
	rm -f $(APPNAME) dialog.o

$(APPNAME): $(SRCNAME) dialog.o
	$(CC) $(CFLAGS) -s -o $@ $< dialog.o $(LIBS) -Wl,--gc-sections

=== debian/changelog ===
jpegqs (1.20210408-3) unstable; urgency=medium

  * Fix a divide by zero on corrupted images (closes: #1017608,
    CVE-2022-35434).

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 18 Aug 2022 14:23:00 +0200

jpegqs (1.20210408-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make. (Closes: #992507)

  [ Adam Borowski ]
  * Add Thomas G. Lane to d/copyright.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 22 Aug 2021 03:55:40 +0200

jpegqs (1.20210408-1) unstable; urgency=medium

  * Initial release (Closes: #989697)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 30 Jun 2021 17:59:52 +0200

=== debian/control ===
Source: jpegqs
Section: graphics
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 13), libjpeg-dev
Standards-Version: 4.5.1
Homepage: https://github.com/ilyakurdyukov/jpeg-quantsmooth/
Vcs-Browser: https://github.com/kilobyte/jpegqs
Vcs-Git: https://github.com/kilobyte/jpegqs
Rules-Requires-Root: no

Package: jpegqs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JPEG artifacts removal tool
 JPEG Quant Smooth tries to recover the lost precision of DCT
 coefficients based on a quantization table from a JPEG image.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all


%:
	dh $@

build-arch:
	if dpkg-architecture --is any-amd64; then \
		dh_auto_build -- SIMD=select $(shell dpkg-buildflags --export=cmdline); \
	else \
		dh_auto_build -- SIMD=none $(shell dpkg-buildflags --export=cmdline); \
	fi

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%jpegqs-$1.tar.gz%" \
   https://github.com/ilyakurdyukov/jpeg-quantsmooth/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
